<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\Antenne;

use App\Entity\Antenne;
use App\Payload\ResponseApi;
use App\Repository\AntenneRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class CreateAntenneRequestAction extends AbstractController
{
    public function __invoke(Request $request, AntenneRepository $antenneRepository): mixed
    {
         /** @var \App\Entity\User $user */
         $user = $this->getUser();

        $antenne = new Antenne;
        $post_data = json_decode($request->getContent(), true);
        
        $antenne->setLibelle($post_data['libelle']);
        $antenne->setEstSupprimer(false);
        $antenne->setCreatedAt(new \DateTimeImmutable());
        $antenne->setUpdatedAt(new \DateTimeImmutable());
        $antenne->setUpdatedBy($user->getId());
        $antenne->setCreatedBy($user->getId());
        $antenneRepository->save($antenne, true);
        
        //return new ResponseApi(true, "Thématique créée avec succès !", $antenne);
        return $antenne;
    }
}
