<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\CategorieFaq;

use App\Entity\CategorieFaq;
use App\Payload\ResponseApi;
use App\Repository\CategorieFaqRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class CreateCategorieFaqRequestAction extends AbstractController
{
    public function __invoke(Request $request, CategorieFaqRepository $categorieFaqRepository): mixed
    {
         /** @var \App\Entity\User $user */
         $user = $this->getUser();

        $categorieFaq = new CategorieFaq;
        $post_data = json_decode($request->getContent(), true);
        
        $categorieFaq->setLibelle($post_data['libelle']);
        $categorieFaq->setEstSupprimer(false);
        $categorieFaq->setCreatedAt(new \DateTimeImmutable());
        $categorieFaq->setUpdatedAt(new \DateTimeImmutable());
        $categorieFaq->setUpdatedBy($user->getId());
        $categorieFaq->setCreatedBy($user->getId());
        $categorieFaqRepository->save($categorieFaq, true);
        
        //return new ResponseApi(true, "Thématique créée avec succès !", $categorieFaq);
        return $categorieFaq;
    }
}
