<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\CategoriePublication;

use App\Payload\ResponseApi;
use App\Repository\CategoriePublicationRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class DeleteCategoriePublicationRequestAction extends AbstractController
{
    public function __invoke(Request $request, HttpClientInterface $client, CategoriePublicationRepository $categoriePublicationRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();
        
        $post_data = json_decode($request->get('id'), true);
        
        $categoriePublication = $categoriePublicationRepository->find($post_data);

        if($categoriePublication != null) {
            $categoriePublication->setEstSupprimer(true);
            $categoriePublication->setUpdatedAt(new \DateTimeImmutable());
            $categoriePublication->setUpdatedBy($user->getId());
            $categoriePublicationRepository->save($categoriePublication, true);
        }
        
        //return new ResponseApi(true, "Suppression effectuée", $categoriePublication);
        return $categoriePublication;
    }
}
