<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\Contact;

use App\Payload\ResponseApi;
use App\Repository\ContactRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class DeleteContactRequestAction extends AbstractController
{
    public function __invoke(Request $request, HttpClientInterface $client, ContactRepository $contactRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();
        
        $post_data = json_decode($request->get('id'), true);
        
        $contact = $contactRepository->find($post_data);

        if($contact != null) {
            $contact->setEstSupprimer(true);
            $contact->setUpdatedAt(new \DateTimeImmutable());
            $contact->setUpdatedBy($user->getId());
            $contactRepository->save($contact, true);
        }
        
        //return new ResponseApi(true, "Suppression effectuée", $contact);
        return $contact;
    }
}
