<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\CustomerSubject;

use App\Payload\ResponseApi;
use App\Repository\CustomerSubjectRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class DeleteCustomerSubjectRequestAction extends AbstractController
{
    public function __invoke(Request $request, HttpClientInterface $client, CustomerSubjectRepository $customerSubjectRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();
        
        $post_data = json_decode($request->get('id'), true);
        
        $customerSubject = $customerSubjectRepository->find($post_data);

        if($customerSubject != null) {
            $customerSubject->setEstSupprimer(true);
            $customerSubject->setUpdatedAt(new \DateTimeImmutable());
            $customerSubject->setUpdatedBy($user->getId());
            $customerSubjectRepository->save($customerSubject, true);
        }
        
        //return new ResponseApi(true, "Suppression effectuée", $customerSubject);
        return $customerSubject;
    }
}
