<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\CustomerSubject;

use App\Payload\ResponseApi;
use App\Repository\CustomerSubjectRepository;
use App\Repository\AntenneRepository;
use App\Repository\MediaObjectRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;

#[AsController]
final class UpdateCustomerSubjectRequestAction extends AbstractController
{
    public function __invoke(Request $request, MediaObjectRepository $mediaObjectRepository, CustomerSubjectRepository $customerSubjectRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();

        $id = json_decode($request->get('id'), true);
        $post_data = json_decode($request->getContent(), true);
        
        $customerSubject = $customerSubjectRepository->find($id);
        
        $mediaObject = null;
        if($post_data['mediaObject'] != null && $post_data['mediaObject'] != null) {
            $mediaObject = $mediaObjectRepository->find($post_data['mediaObject']);
        }
       
        $customerSubject->setMediaObject($mediaObject);
        $customerSubject->setDescription($post_data['description']);
        $customerSubject->setCategorieSubject($post_data['categorieSubject']);
        $customerSubject->setEstSupprimer(false);
        $customerSubject->setCreatedAt(new \DateTimeImmutable());
        $customerSubject->setUpdatedAt(new \DateTimeImmutable());
        $customerSubject->setUpdatedBy($user->getId());
        $customerSubjectRepository->save($customerSubject, true);
        
        //return new ResponseApi(true, "Thématique créée avec succès !", $customerSubject);
        return $customerSubject;
    }
}
