<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\Faq;

use App\Payload\ResponseApi;
use App\Repository\FaqRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class DeleteFaqRequestAction extends AbstractController
{
    public function __invoke(Request $request, HttpClientInterface $client, FaqRepository $faqRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();
        
        $post_data = json_decode($request->get('id'), true);
        
        $faq = $faqRepository->find($post_data);

        if($faq != null) {
            $faq->setEstSupprimer(true);
            $faq->setUpdatedAt(new \DateTimeImmutable());
            $faq->setUpdatedBy($user->getId());
            $faqRepository->save($faq, true);
        }
        
        //return new ResponseApi(true, "Suppression effectuée", $faq);
        return $faq;
    }
}
