<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\FlashInfo;

use App\Payload\ResponseApi;
use App\Repository\FlashInfoRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class DeleteFlashInfoRequestAction extends AbstractController
{
    public function __invoke(Request $request, HttpClientInterface $client, FlashInfoRepository $flashInfoRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();
        
        $post_data = json_decode($request->get('id'), true);
        
        $flashInfo = $flashInfoRepository->find($post_data);

        if($flashInfo != null) {
            $flashInfo->setEstSupprimer(true);
            $flashInfo->setUpdatedAt(new \DateTimeImmutable());
            $flashInfo->setUpdatedBy($user->getId());
            $flashInfoRepository->save($flashInfo, true);
        }
        
        //return new ResponseApi(true, "Suppression effectuée", $flashInfo);
        return $flashInfo;
    }
}
