<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\FlashInfo;

use App\Payload\ResponseApi;
use App\Repository\FlashInfoRepository;
use App\Repository\AntenneRepository;
use App\Repository\PublicationRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class UpdateFlashInfoRequestAction extends AbstractController
{
    public function __invoke(Request $request, PublicationRepository $publicationRepository,
     FlashInfoRepository $flashInfoRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();

        $id = json_decode($request->get('id'), true);
        $post_data = json_decode($request->getContent(), true);
        
        $flashInfo = $flashInfoRepository->find($id);
        
        $publication = null;
        if($post_data['publication'] != null && $post_data['publication'] != null) {
            $publication = $publicationRepository->find($post_data['publication']);
        }
       
        $flashInfo->setPublication($publication);
        $flashInfo->setTitre($post_data['titre']);
        $flashInfo->setEstPubliser($post_data['estPubliser']);

        $flashInfo->setEstSupprimer(false);
        $flashInfo->setCreatedAt(new \DateTimeImmutable());
        $flashInfo->setUpdatedAt(new \DateTimeImmutable());
        $flashInfo->setUpdatedBy($user->getId());
        $flashInfoRepository->save($flashInfo, true);
        
        //return new ResponseApi(true, "Thématique créée avec succès !", $flashInfo);
        return $flashInfo;
    }
}
