<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller;

use App\Payload\ResponseApi;
use App\Repository\UserRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Component\PasswordHasher\Hasher\UserPasswordHasherInterface;

#[AsController]
final class ResetPasswordAction extends AbstractController
{
    public function __invoke(Request $request, UserRepository $userRepository, UserPasswordHasherInterface $passwordHasher): mixed
    {
        $post_data = json_decode($request->getContent(), true);

        /** @var \App\Entity\User $user */
        $user = $this->getUser();
        $password = $post_data['password'];
        if ($user != null) {
            $hashedPassword = $passwordHasher->hashPassword(
                $user,
                $password
            );
            $user->setPassword($hashedPassword);
            $user->setEstSupprimer(false);
            $userRepository->save($user, true);
        }
        $user->setPassword('');
        return new ResponseApi(true, "Votre mot de passe est changé avec succès" , $user);
    }
}
