<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller;

use App\Entity\User;
use App\Payload\ResponseApi;
use App\Repository\UserRepository;
use App\Service\MailSenderService;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Component\PasswordHasher\Hasher\UserPasswordHasherInterface;

#[AsController]
final class SignupAction extends AbstractController
{
    public function __invoke(Request $request, UserRepository $userRepository, UserPasswordHasherInterface $passwordHasher): mixed
    {
        $post_data = json_decode($request->getContent(), true);

        $user = new User();
        $user->setNom($post_data['nom']);
        $user->setPrenom($post_data['prenom']);
        $user->setEmail($post_data['email']);
        $user->setTel($post_data['tel']);
        $user->setPassword($post_data['password']);
        $user->setEstSupprimer(false);
        $user->setCreatedBy(0);
        $user->setUpdatedBy(0);

        $plaintPassword = $user->getPassword();
        $hashedPassword = $passwordHasher->hashPassword(
            $user,
            $user->getPassword()
        );
        $user->setPassword($hashedPassword);
        $user->setRoles(['ROLE_USER']);
        $user->setEstSupprimer(false);
        $userRepository->save($user, true);
        /* MAIL 
        $nomDestinataire = $user->getPrenom().' '.$user->getNom();
        $message = "Vos identifiants de connexion sont : <br> Identifiant : <strong>" . $user->getEmail() . "</strong> <br> Mot de passe : <strong>" . $plaintPassword . "</strong>.";
        $html = $this->renderView('mail.html.twig', [
            'message' => $message,
            'nomDestinataire' => $nomDestinataire
        ]);
        $subject = 'Communication de vos identifiant de connexion.';

        $mailService =  new MailSenderService;
        $mailService->sendMail($html, $nomDestinataire, $user->getEmail(), $subject);
        FIN MAIL */

        $user->setPassword('');
        return new ResponseApi(true, "Votre inscription s'est déroulée avec succès" , $user);
    }
}
