<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\Slider;

use App\Repository\CategorieSliderRepository;
use App\Repository\SliderRepository;
use App\Repository\MediaObjectRepository;
use App\Repository\PublicationRepository;
use App\Repository\TagRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;

#[AsController]
final class UpdateSliderRequestAction extends AbstractController
{
    public function __invoke(Request $request, SliderRepository $sliderRepository, 
    MediaObjectRepository $mediaObjectRepository, PublicationRepository $publicationRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();

        $id = json_decode($request->get('id'), true);
        $post_data = json_decode($request->getContent(), true);

        $slider = $sliderRepository->find($id);
        
        $mediaObject = null;
        if($post_data['mediaObject'] != null && $post_data['mediaObject'] != null) {
            $mediaObject = $mediaObjectRepository->find($post_data['mediaObject']);
        }

        $publication = null;
        if($post_data['publication'] != null && $post_data['publication'] != null) {
            $publication = $publicationRepository->find($post_data['publication']);
        }

        $slider->setTitre($post_data['titre']);
        $slider->setContenu($post_data['contenu']);
        $slider->setEstPubliser($post_data['estPubliser']);
        $slider->setMediaObject($mediaObject);
        $slider->setPublication($publication);


        $slider->setEstSupprimer(false);
        $slider->setCreatedAt(new \DateTimeImmutable());
        $slider->setUpdatedAt(new \DateTimeImmutable());
        $slider->setUpdatedBy($user->getId());
        $slider->setCreatedBy($user->getId());
        $sliderRepository->save($slider, true);
        
        //return new ResponseApi(true, "Thématique créée avec succès !", $slider);
        return $slider;
    }
}
